/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pa156.demo.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author bar
 */
public class PizzaDB {
    
    private Connection con;
    private PreparedStatement insertOrder;
    private PreparedStatement selectOrders;
    public PizzaDB(){
        try {
            try {
                Class.forName("org.apache.derby.jdbc.EmbeddedDriver");
            } catch (ClassNotFoundException ex) {
                Logger.getLogger(PizzaDB.class.getName()).log(Level.SEVERE, "Driver not found.", ex);
            }
            con = DriverManager.getConnection("jdbc:derby:/home/bar/.netbeans-derby/pizzeria;create=true","bar","barbar");
            insertOrder = con.prepareStatement("insert into BAR.ORDERS(KIND,TOPPING,DRINK) values(?,?,?)", Statement.RETURN_GENERATED_KEYS);
            selectOrders = con.prepareStatement("select KIND, TOPPING, DRINK from BAR.ORDERS");
        } catch (SQLException ex) {
            Logger.getLogger(PizzaDB.class.getName()).log(Level.SEVERE, "Unable to connect database.", ex);
            System.exit(-1);
        }
    }
        
    public void addOrder(Order order){
        try {
            insertOrder.setString(1, order.getKind());
            insertOrder.setString(2, order.getTopping());
            insertOrder.setString(3,order.getDrink());
            int executeUpdate = insertOrder.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(PizzaDB.class.getName()).log(Level.SEVERE, "Error adding new order.", ex);
        }
    }
    
    public List<Order> getOrders(){
        List<Order> orders = new ArrayList<>();
        try {
            
            ResultSet result = selectOrders.executeQuery();
            while(result.next()){
                Order order= new Order();
                order.setKind(result.getString("KIND"));
                order.setTopping(result.getString("TOPPING"));
                order.setDrink(result.getString("DRINK"));
                orders.add(order);
            }
        } catch (SQLException ex) {
            Logger.getLogger(PizzaDB.class.getName()).log(Level.SEVERE, "Error getting order.", ex);
        }
        return orders;
    }
}
    
